/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Sun Jan 15 12:55:08 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001E3F (7743)
 *     Revision         0x01
 *     Checksum         0x93
 *     OEM ID           "AmdRef"
 *     OEM Table ID     "AmdTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20100121 (537919777)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "AmdRef", "AmdTabl", 0x00001000)
{
    External (EBAS, MethodObj)    // 1 Arguments
    External (MBGS, MethodObj)    // 1 Arguments
    External (BRTL, IntObj)
    External (ASLB, MethodObj)    // 1 Arguments
    External (LIDS, MethodObj)    // 0 Arguments
    External (PWRS, MethodObj)    // 1 Arguments
    External (NDID)
    External (DID8)
    External (DID7)
    External (DID6)
    External (DID5)
    External (DID4)
    External (DID3)
    External (DID2)
    External (DID1)
    External (BID_)
    External (SGMD)
    External (AMDA, MethodObj)    // 1 Arguments
    External (\EECP, MethodObj)    // 1 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (\_SB_.EMSC.SETD, MethodObj)    // 1 Arguments
    External (\_SB_.EMSC.GETD, IntObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0._DOD, IntObj)
    External (\_SB_.PCI0.GFX0.CLID)
    External (\_SB_.PCI0.GFX0.AINT, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0.GLID, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.GFX0.DD02)
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (\_SB_.PCI0.LPCB.EC0_.BRTS)
    External (\_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)
    External (\_SB_.PCI0.LPCB.EC0_.LIDP)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                ,   1, 
            PO01,   1, 
                ,   4, 
            PI06,   1, 
                ,   10, 
            PI17,   1, 
                ,   12, 
            PO30,   1, 
                    Offset (0x38), 
                ,   6, 
            PI38,   1, 
                ,   7, 
            PO46,   1, 
                ,   3, 
            PO50,   1, 
            PO51,   1, 
            PO52,   1, 
            PO53,   1, 
            PO54,   1, 
                    Offset (0x48), 
                ,   4, 
            PO68,   1
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    Return (Buffer (0x04)
                    {
                        0x03, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    Return (Package (0x09)
                    {
                        0x08, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                0x01, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                0x02, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010300, 
                            Buffer (0x04)
                            {
                                0x08, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010301, 
                            Buffer (0x04)
                            {
                                0x04, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010302, 
                            Buffer (0x04)
                            {
                                0x09, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010303, 
                            Buffer (0x04)
                            {
                                0x05, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010304, 
                            Buffer (0x04)
                            {
                                0x06, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010306, 
                            Buffer (0x04)
                            {
                                0x0E, 0x01, 0x01, 0x01
                            }
                        }
                    })
                }

                Return (One)
            }

            Return (One)
        }

        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                        Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                        Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                        Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                PXMS,   8, 
                FDSS,   8, 
                DISM,   8, 
                        Offset (0x210), 
                        Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                        Offset (0x250), 
                SUPD,   16, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                        Offset (0x3C0), 
                TVSD,   8, 
                EXPM,   8, 
                BPSD,   16, 
                BSPD,   16, 
                TLSN,   16, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Method (ATPX, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                Store (0x08, F0SS)
                Store (One, F0IV)
                Store (0xBF, F0SF)
                If (LEqual (PXMS, One))
                {
                    Store (0x33, F0SF)
                }

                If (LEqual (And (FDSS, 0x02), 0x02))
                {
                    And (F0SF, 0xFFFFFFFD, F0SF)
                }

                If (LEqual (And (FDSS, One), One))
                {
                    Or (F0SF, 0x02, F0SF)
                }

                Return (TMP1)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                Store (0x0A, F1SS)
                If (LEqual (PXMS, One))
                {
                    Store (0x80, F1VM)
                    Store (0x80, F1FG)
                }
                Else
                {
                    Store (0x40, F1VM)
                    Store (0x40, F1FG)
                }

                Return (TMP2)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If (LEqual (DGPR, Zero))
                {
                    \_SB.PCI0.PEG0.PEGP._OFF ()
                    Store (Zero, SGMD)
                }

                If (LEqual (DGPR, One))
                {
                    \_SB.PCI0.PEG0.PEGP._ON ()
                    Store (One, SGMD)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                If (LEqual (SDMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO52)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO52)
                    }

                    If (LLess (BID, 0x04))
                    {
                        If (Zero)
                        {
                            Store (Zero, \_SB.PCI0.PEG0.PEGP.PO68)
                        }
                        Else
                        {
                            Store (One, \_SB.PCI0.PEG0.PEGP.PO68)
                        }
                    }
                }

                If (LEqual (SDMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO52)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO52)
                    }

                    If (LLess (BID, 0x04))
                    {
                        If (Ones)
                        {
                            Store (Zero, \_SB.PCI0.PEG0.PEGP.PO68)
                        }
                        Else
                        {
                            Store (One, \_SB.PCI0.PEG0.PEGP.PO68)
                        }
                    }
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                If (LEqual (SIMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO01)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO01)
                    }
                }

                If (LEqual (SIMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.PEG0.PEGP.PO01)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.PEG0.PEGP.PO01)
                    }
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                Store (TGFX, TGXA)
                Store (One, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                Store (AGFX, AGXA)
                Store (Zero, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, NOCN)
                CreateWordField (TMP3, 0x02, CNSS)
                Store (0x0F, NOCN)
                Store (0x4B, CNSS)
                CreateByteField (TMP3, 0x04, FLG1)
                CreateByteField (TMP3, 0x05, ATI1)
                CreateByteField (TMP3, 0x06, ADI1)
                CreateWordField (TMP3, 0x07, ACP1)
                Store (0x07, FLG1)
                Store (One, ATI1)
                Store (Zero, ADI1)
                Store (0x0100, ACP1)
                CreateByteField (TMP3, 0x09, FLG2)
                CreateByteField (TMP3, 0x0A, ATI2)
                CreateByteField (TMP3, 0x0B, ADI2)
                CreateWordField (TMP3, 0x0C, ACP2)
                Store (0x07, FLG2)
                Store (One, ATI2)
                Store (One, ADI2)
                Store (0x0100, ACP2)
                CreateByteField (TMP3, 0x0E, FLG3)
                CreateByteField (TMP3, 0x0F, ATI3)
                CreateByteField (TMP3, 0x10, ADI3)
                CreateWordField (TMP3, 0x11, ACP3)
                Store (0x05, FLG3)
                Store (Zero, ATI3)
                Store (Zero, ADI3)
                Store (0x0400, ACP3)
                CreateByteField (TMP3, 0x13, FLG4)
                CreateByteField (TMP3, 0x14, ATI4)
                CreateByteField (TMP3, 0x15, ADI4)
                CreateWordField (TMP3, 0x16, ACP4)
                Store (0x05, FLG4)
                Store (Zero, ATI4)
                Store (One, ADI4)
                Store (0x0110, ACP4)
                CreateByteField (TMP3, 0x18, FLG5)
                CreateByteField (TMP3, 0x19, ATI5)
                CreateByteField (TMP3, 0x1A, ADI5)
                CreateWordField (TMP3, 0x1B, ACP5)
                Store (0x07, FLG5)
                Store (0x03, ATI5)
                Store (Zero, ADI5)
                Store (0x0300, ACP5)
                CreateByteField (TMP3, 0x1D, FLG6)
                CreateByteField (TMP3, 0x1E, ATI6)
                CreateByteField (TMP3, 0x1F, ADI6)
                CreateWordField (TMP3, 0x20, ACP6)
                Store (0x07, FLG6)
                Store (0x03, ATI6)
                Store (One, ADI6)
                Store (0x0210, ACP6)
                CreateByteField (TMP3, 0x22, FLG7)
                CreateByteField (TMP3, 0x23, ATI7)
                CreateByteField (TMP3, 0x24, ADI7)
                CreateWordField (TMP3, 0x25, ACP7)
                Store (0x07, FLG7)
                Store (0x07, ATI7)
                Store (Zero, ADI7)
                Store (0x0301, ACP7)
                CreateByteField (TMP3, 0x27, FLG8)
                CreateByteField (TMP3, 0x28, ATI8)
                CreateByteField (TMP3, 0x29, ADI8)
                CreateWordField (TMP3, 0x2A, ACP8)
                Store (0x07, FLG8)
                Store (0x07, ATI8)
                Store (One, ADI8)
                Store (0x0210, ACP8)
                CreateByteField (TMP3, 0x2C, FLG9)
                CreateByteField (TMP3, 0x2D, ATI9)
                CreateByteField (TMP3, 0x2E, ADI9)
                CreateWordField (TMP3, 0x2F, ACP9)
                Store (0x07, FLG9)
                Store (0x09, ATI9)
                Store (Zero, ADI9)
                Store (0x0302, ACP9)
                CreateByteField (TMP3, 0x31, FLGA)
                CreateByteField (TMP3, 0x32, ATIA)
                CreateByteField (TMP3, 0x33, ADIA)
                CreateWordField (TMP3, 0x34, ACPA)
                Store (0x07, FLGA)
                Store (0x09, ATIA)
                Store (One, ADIA)
                Store (0x0220, ACPA)
                CreateByteField (TMP3, 0x36, FLGB)
                CreateByteField (TMP3, 0x37, ATIB)
                CreateByteField (TMP3, 0x38, ADIB)
                CreateWordField (TMP3, 0x39, ACPB)
                Store (0x07, FLGB)
                Store (0x0A, ATIB)
                Store (Zero, ADIB)
                Store (0x0303, ACPB)
                CreateByteField (TMP3, 0x3B, FLGC)
                CreateByteField (TMP3, 0x3C, ATIC)
                CreateByteField (TMP3, 0x3D, ADIC)
                CreateWordField (TMP3, 0x3E, ACPC)
                Store (0x07, FLGC)
                Store (0x0A, ATIC)
                Store (One, ADIC)
                Store (0x0220, ACPC)
                CreateByteField (TMP3, 0x40, FLGD)
                CreateByteField (TMP3, 0x41, ATID)
                CreateByteField (TMP3, 0x42, ADID)
                CreateWordField (TMP3, 0x43, ACPD)
                Store (0x07, FLGD)
                Store (0x0B, ATID)
                Store (Zero, ADID)
                Store (0x0304, ACPD)
                CreateByteField (TMP3, 0x45, FLGE)
                CreateByteField (TMP3, 0x46, ATIE)
                CreateByteField (TMP3, 0x47, ADIE)
                CreateWordField (TMP3, 0x48, ACPE)
                Store (0x07, FLGE)
                Store (0x0B, ATIE)
                Store (One, ADIE)
                Store (0x0230, ACPE)
                CreateByteField (TMP3, 0x4A, FLGF)
                CreateByteField (TMP3, 0x4B, ATIF)
                CreateByteField (TMP3, 0x4C, ADIF)
                CreateWordField (TMP3, 0x4D, ACPF)
                Store (0x05, FLGF)
                Store (0x0C, ATIF)
                Store (Zero, ADIF)
                Store (0x0306, ACPF)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Method (IDAB, 0, Serialized)
    {
        Store (0x80010100, DID1)
        Store (0x80010400, DID2)
        Store (0x80010300, DID3)
        Store (0x80010301, DID4)
        Store (0x80010302, DID5)
        Store (0x80010303, DID6)
        Store (0x80010304, DID7)
        Store (0x80010306, DID8)
        Store (0x08, NDID)
    }

    Method (HGAS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (PWRS (\_SB.PCI0.GFX0.AFN4 (One))) {}
            Else
            {
                \_SB.PCI0.GFX0.AFN4 (0x02)
            }
        }
    }

    Method (HBRT, 1, Serialized)
    {
        If (LEqual (Arg0, 0x04))
        {
            Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x87)
            Notify (\_SB.PCI0.GFX0.DD02, 0x87)
        }

        If (LEqual (Arg0, 0x03))
        {
            Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x86)
            Notify (\_SB.PCI0.GFX0.DD02, 0x86)
        }
    }

    Method (HLSE, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GLID (LIDS ())
            }
        }
    }

    Method (HDSE, 1, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                If (LEqual (Arg0, Zero))
                {
                    Return (\_SB.EMSC.GETD)
                }
                Else
                {
                    \_SB.EMSC.SETD (Arg0)
                }
            }
            Else
            {
                If (LEqual (Arg0, Zero))
                {
                    Store (Zero, \_SB.PCI0.GFX0.DSFL)
                    \_SB.PCI0.GFX0.AFN0 ()
                    Return (\_SB.PCI0.GFX0.MADL)
                }
                Else
                {
                    Store (One, \_SB.PCI0.GFX0.DSFL)
                    Store (Arg0, \_SB.PCI0.GFX0.MSTE)
                    \_SB.PCI0.GFX0.AFN0 ()
                }
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                \_SB.PCI0.GFX0.AFN1 ()
            }
        }
    }

    Method (HGLS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                If (\_SB.PCI0.GFX0.GLID (LIDS ()))
                {
                    Or (0x80000000, \_SB.PCI0.GFX0.CLID, \_SB.PCI0.GFX0.CLID)
                }
            }
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        \_SB.PCI0.GFX0.AFN5 ()
    }

    Method (PXPW, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (PWRS (\_SB.PCI0.GFX0.AFN4 (One))) {}
            Else
            {
                \_SB.PCI0.GFX0.AFN4 (0x02)
            }
        }
    }

    Method (PXGS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            \_SB.PCI0.GFX0.AFN6 ()
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Name (PSBR, Buffer (0x04)
        {
            0x00, 0x00, 0x00, 0x00
        })
        Name (NCOD, 0x81)
        Name (MSKN, Zero)
        Name (MADL, Zero)
        Name (DSFL, Zero)
        Name (MSTE, Zero)
        Name (DPFL, One)
        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                Store (0x0C, F0SS)
                Store (One, F0IV)
                Store (0xD1, F0SN)
                Store (F0SN, MSKN)
                Store (0x07, F0SF)
                Return (TMP0)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x03, F1VF)
                Store (One, F1FG)
                Store (0x81, NCOD)
                Return (TMP1)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateBitField (PSBR, Zero, PDSW)
                CreateBitField (PSBR, One, PEXM)
                CreateBitField (PSBR, 0x02, PTHR)
                CreateBitField (PSBR, 0x03, PFPS)
                CreateBitField (PSBR, 0x04, PSPS)
                CreateBitField (PSBR, 0x05, PDCC)
                CreateBitField (PSBR, 0x06, PXPS)
                CreateBitField (PSBR, 0x07, PBRT)
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F2SS)
                CreateDWordField (TMP2, 0x02, F2PR)
                CreateByteField (TMP2, 0x06, F2EM)
                CreateByteField (TMP2, 0x07, F2TG)
                CreateByteField (TMP2, 0x08, F2SI)
                CreateByteField (TMP2, 0x09, F2FG)
                CreateByteField (TMP2, 0x0A, F2FI)
                CreateByteField (TMP2, 0x0B, F2SP)
                CreateByteField (TMP2, 0x0C, F2BR)
                Store (0x0D, F2SS)
                Store (PSBR, F2PR)
                If (PDSW)
                {
                    Store (Zero, MADL)
                    Store (Zero, PDSW)
                }

                If (PEXM)
                {
                    Store (EXPM, F2EM)
                    Store (Zero, EXPM)
                    Store (Zero, PEXM)
                }

                If (PTHR)
                {
                    Store (TSTG, F2TG)
                    Store (TSSI, F2SI)
                    Store (Zero, TSTG)
                    Store (Zero, TSSI)
                    Store (Zero, PTHR)
                }

                If (PFPS)
                {
                    Store (FPTG, F2FG)
                    Store (FPSI, F2FI)
                    Store (Zero, FPTG)
                    Store (Zero, FPSI)
                    Store (Zero, PFPS)
                }

                If (PSPS)
                {
                    Store (SPWS, F2SP)
                    Store (Zero, PSPS)
                }

                If (PXPS)
                {
                    Store (Zero, PXPS)
                }

                If (PBRT)
                {
                    Store (BRTL, F2BR)
                    Store (Zero, PBRT)
                }

                Return (TMP2)
            }

            If (LEqual (Arg0, 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                If (LEqual (\_SB.PCI0.LPCB.EC0.LIDP, Zero))
                {
                    Or (MADL, 0x08, MADL)
                }

                If (And (CODS, 0x02))
                {
                    Or (MADL, 0x02, MADL)
                }

                If (And (CODS, 0x0200))
                {
                    Or (MADL, One, MADL)
                }

                If (And (CODS, 0x08))
                {
                    Or (MADL, 0x04, MADL)
                }

                Store (0x04, F3SS)
                If (LEqual (DSFL, Zero))
                {
                    MBGS ("DSFL_0")
                    Store (SLDS, F3SD)
                    Return (TMP3)
                }

                MBGS ("DSFL_1")
                Store (MSTE, CACD)
                Store (SATL (CACD), Local1)
                Store (Local1, NACD)
                Store (NACD, F3SD)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (SATL, 1, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (ToInteger (Arg0), _T_0)
                If (LEqual (_T_0, One))
                {
                    Return (0x0200)
                }
                Else
                {
                    If (LEqual (_T_0, 0x02))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x03))
                        {
                            Return (0x0202)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x04))
                            {
                                Return (0x08)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x05))
                                {
                                    Return (0x0208)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x06))
                                    {
                                        Return (0x0A)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x07))
                                        {
                                            Return (0x020A)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x08))
                                            {
                                                Return (One)
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x09))
                                                {
                                                    Return (0x0201)
                                                }
                                                Else
                                                {
                                                    If (LEqual (_T_0, 0x0A))
                                                    {
                                                        Return (0x03)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (_T_0, 0x0B))
                                                        {
                                                            Return (0x0203)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (_T_0, 0x0C))
                                                            {
                                                                Return (0x09)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (_T_0, 0x0D))
                                                                {
                                                                    Return (0x0209)
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (_T_0, 0x0E))
                                                                    {
                                                                        Return (0x0B)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                Break
            }
        }

        Method (COTA, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (TLE1, Arg0))
                {
                    Return (One)
                }

                If (LEqual (TLE2, Arg0))
                {
                    Return (0x02)
                }

                If (LEqual (TLE3, Arg0))
                {
                    Return (0x03)
                }

                If (LEqual (TLE4, Arg0))
                {
                    Return (0x04)
                }

                If (LEqual (TLE5, Arg0))
                {
                    Return (0x05)
                }

                If (LEqual (TLE6, Arg0))
                {
                    Return (0x06)
                }

                If (LEqual (TLE7, Arg0))
                {
                    Return (0x07)
                }

                If (LEqual (TLE8, Arg0))
                {
                    Return (0x08)
                }

                If (LEqual (TLE9, Arg0))
                {
                    Return (0x09)
                }

                If (LEqual (TL10, Arg0))
                {
                    Return (0x0A)
                }

                If (LEqual (TL11, Arg0))
                {
                    Return (0x0B)
                }

                If (LEqual (TL12, Arg0))
                {
                    Return (0x0C)
                }

                If (LEqual (TL13, Arg0))
                {
                    Return (0x0D)
                }

                If (LEqual (TL14, Arg0))
                {
                    Return (0x0E)
                }

                If (LEqual (TL15, Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (NATL, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (Arg0, One))
                {
                    Return (TLE2)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Return (TLE3)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Return (TLE4)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Return (TLE5)
                }

                If (LEqual (Arg0, 0x05))
                {
                    Return (TLE6)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Return (TLE7)
                }

                If (LEqual (Arg0, 0x07))
                {
                    Return (TLE8)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Return (TLE9)
                }

                If (LEqual (Arg0, 0x09))
                {
                    Return (TL10)
                }

                If (LEqual (Arg0, 0x0A))
                {
                    Return (TL11)
                }

                If (LEqual (Arg0, 0x0B))
                {
                    Return (TL12)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Return (TL13)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Return (TL14)
                }

                If (LEqual (Arg0, 0x0E))
                {
                    Return (TL15)
                }

                If (LEqual (Arg0, 0x0F))
                {
                    Return (TLE1)
                }
            }

            Return (Zero)
        }

        Method (AFN0, 0, Serialized)
        {
            If (And (MSKN, One))
            {
                CreateBitField (PSBR, Zero, PDSW)
                Store (One, PDSW)
                Notify (\_SB.PCI0.PEG0.PEGP, NCOD)
                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }

        Method (AFN1, 0, Serialized)
        {
            If (And (MSKN, 0x02))
            {
                CreateBitField (PSBR, One, PEXM)
                Store (One, PEXM)
                If (LEqual (EXPM, 0x02))
                {
                    Store (Zero, EXPM)
                }
                Else
                {
                    Increment (EXPM)
                }

                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }

        Method (AFN3, 2, Serialized)
        {
            If (And (MSKN, 0x08))
            {
                Store (Arg0, Local0)
                Store (Local0, FPSI)
                Store (Arg1, Local0)
                Store (And (Local0, 0x03, Local0), FPTG)
                CreateBitField (PSBR, 0x03, PFPS)
                Store (One, PFPS)
                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }

        Method (AFN4, 1, Serialized)
        {
            If (And (MSKN, 0x10))
            {
                Store (Arg0, Local0)
                Store (SPWS, Local1)
                Store (Local0, SPWS)
                If (LEqual (Local0, Local1)) {}
                Else
                {
                    CreateBitField (PSBR, 0x04, PSPS)
                    Store (One, PSPS)
                    Notify (\_SB.PCI0.GFX0, NCOD)
                }
            }
        }

        Method (AFN5, 0, Serialized)
        {
            If (And (MSKN, 0x20))
            {
                CreateBitField (PSBR, 0x05, PDCC)
                Store (One, PDCC)
                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }

        Method (AFN6, 0, Serialized)
        {
            If (And (MSKN, 0x40))
            {
                CreateBitField (PSBR, 0x06, PXPS)
                Store (One, PXPS)
                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }

        Method (AFN7, 1, Serialized)
        {
            If (And (MSKN, 0x80))
            {
                CreateBitField (PSBR, 0x07, PBRT)
                Store (One, PBRT)
                Store (Arg0, BRTL)
                Notify (\_SB.PCI0.GFX0, NCOD)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (PWRE, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO50)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO50)
            }

            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO54)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO54)
            }

            Sleep (0x32)
            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO46)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO46)
            }

            Sleep (0xFA)
            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO50)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO50)
            }

            Sleep (0x64)
        }

        Method (PWRD, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO50)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO50)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO46)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO46)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO54)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO54)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, PCI_Config, Zero, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x8400), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x8214), 
                        Offset (0x8216), 
                LNKS,   4
            })
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        Name (AVID, Zero)
        Name (ADID, Zero)
        OperationRegion (PCIS, SystemMemory, EBAS (0x2000), Field (PCIS, DWordAcc, Lock, Preserve)
            {
                DVID,   16, 
                        Offset (0x2C), 
                SVID,   16, 
                SDID,   16, 
                        Offset (0x4C), 
                WVID,   16, 
                WDID,   16, 
                        Offset (0x104C), 
                VVID,   16, 
                VDID,   16
            })
        OperationRegion (PCAP, SystemMemory, \EECP (0x14), Field (PCAP, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                LCTL,   16
            })
        Field (PCIS, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x04), 
            CMDR,   8, 
            VGAR,   2008
        }

        Name (VGAB, Buffer (0xFB)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0020 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0028 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0030 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0038 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0040 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0048 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0050 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0058 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0060 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0068 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0070 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0078 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0080 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0088 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0090 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0098 */    0x00, 0x00, 0x00
        })
        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            \_SB.PCI0.PEG0.PEGP.PWRE ()
            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (Zero, CMDR)
            Store (VGAB, VGAR)
            Store (0x06, CMDR)
            Store (HVID, WVID)
            Store (HDID, WDID)
            Store (AVID, VVID)
            Store (ADID, VDID)
            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (LCTL, ELCT)
            Store (SVID, HVID)
            Store (SDID, HDID)
            Store (VVID, AVID)
            Store (VDID, ADID)
            Store (VGAR, VGAB)
            Store (One, LNKD)
            While (LLess (LNKS, Zero))
            {
                Sleep (One)
            }

            \_SB.PCI0.PEG0.PEGP.PWRD ()
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_STA, 0, Serialized)
        {
            If (LEqual (DVID, 0xFFFF))
            {
                Return (Zero)
            }
            Else
            {
                Return (0x0F)
            }
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (\_SB.PCI0.GFX0._DOD)
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }

            Method (_DGS, 0, NotSerialized)
            {
                And (\_SB.PCI0.GFX0.MSTE, 0x02, Local0)
                If (Local0)
                {
                    Return (One)
                }
                Else
                {
                    Return (Zero)
                }
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR)
            }

            Method (_DGS, 0, NotSerialized)
            {
                And (\_SB.PCI0.GFX0.MSTE, 0x08, Local0)
                If (Local0)
                {
                    Return (One)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DOS, 1, NotSerialized)
            {
            }

            Method (_BCL, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL)
            }

            Method (_BQC, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC)
            }

            Method (_BCM, 1, NotSerialized)
            {
                If (LAnd (LGreaterEqual (Arg0, Zero), LLessEqual (Arg0, 0x64)))
                {
                    If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
                    {
                        \_SB.PCI0.GFX0.AFN7 (Arg0)
                    }

                    If (LEqual (Arg0, 0x64))
                    {
                        Subtract (Arg0, 0x04, Arg0)
                    }

                    Divide (Arg0, 0x0C, Local0, Local1)
                    Decrement (Local1)
                    Store (Local1, \_SB.PCI0.LPCB.EC0.BRTS)
                }
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LEqual (\_SB.PCI0.GFX0.DPFL, One))
                {
                    And (\_SB.PCI0.GFX0.MSTE, 0x04, Local0)
                    If (Local0)
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR)
            }

            Method (_DGS, 0, NotSerialized)
            {
                And (\_SB.PCI0.GFX0.MSTE, One, Local0)
                If (Local0)
                {
                    Return (One)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }
    }
}

